﻿Imports System.Data.OleDb
Imports System.Security.Cryptography
Imports System.Text
Imports System.IO
Imports System.Text.RegularExpressions

Public Class Staff_Editor
    Dim dbcursor As Integer
    Dim inc As Integer
    Dim MaxRows As Integer
    Dim conn As New OleDb.OleDbConnection
    Dim dbProvider As String
    Dim dbSource As String
    Dim dj As New DataSet
    Dim da As OleDb.OleDbDataAdapter
    Dim sql As String = "SELECT * FROM Department"
    Dim rdr As OleDbDataReader = Nothing
    Dim dtable As New DataTable
    Dim con As OleDbConnection = Nothing
    Dim adp As OleDbDataAdapter
    Dim ds As DataSet
    Dim cmd As OleDbCommand = Nothing
    Private Sub KryptonButton6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeButton1.Click
        Me.Hide()
        XtraMain_Menu.Show()
    End Sub
    Private Sub AutoGenerate()
        ' call this sub from where ever you want to set the value to the new employee code.

        ' declare a variable to hold itemCode
        Dim EmpCode As String = String.Empty
        ' declare a variable to hold curitemCodeNum
        Dim curEmpCodeNum As Integer = 0
        ' declare a variable to hold nextitemCodeNum
        Dim nextEmpCodeNum As Integer = 0
        ' declare a variable to hold addNextNumber
        Dim addNextNumber As Integer = 1

        Using conn As New OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=|DataDirectory|\Payroll_BackEnd.accdb")
            Using cmd As OleDbCommand = conn.CreateCommand
                ''Select statement to select the data in the appropriate field
                cmd.CommandText = ("SELECT MAX(EmployeeCode) FROM Staff_Details")
                Try
                    conn.Open()
                    EmpCode = CStr(cmd.ExecuteScalar)
                Catch ex As Exception
                    Windows.Forms.MessageBox.Show(ex.Message, "Error")
                End Try
            End Using
        End Using

  'split the returned value to keep just the number
        If EmpCode.Contains("NB") Then
            curEmpCodeNum = CInt(EmpCode.Replace("NB", ""))
        End If
        nextEmpCodeNum = curEmpCodeNum + addNextNumber
        Me.EmployeeCodeTextBox.Text = ("NB" & nextEmpCodeNum.ToString("000"))
    End Sub
    Private Sub Staff_Editor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'Payroll_BackEndDataSet.Staff_Details' table. You can move, or remove it, as needed.
        Me.Staff_DetailsTableAdapter.Fill(Me.Payroll_BackEndDataSet.Staff_Details)

        dbProvider = "Provider=Microsoft.ACE.OLEDB.12.0;"
        dbSource = "Data Source=|DataDirectory|\Payroll_BackEnd.accdb"
        conn.ConnectionString = dbProvider & dbSource
        conn.Open()

        da = New OleDb.OleDbDataAdapter(sql, conn)
        da.Fill(dj, "Payroll_BackEnd")

        MaxRows = da.Fill(dj, "Payroll_BackEnd")
        DepartmentCodeTextBox1.Text = dj.Tables("Payroll_BackEnd").Rows(inc).Item(0)
        DepartmentNameTextBox.Text = dj.Tables("Payroll_BackEnd").Rows(inc).Item(1)

        DepartmentCodeTextBox1.Enabled = False
        DepartmentNameTextBox.Enabled = False
        EmployeeCodeTextBox.Enabled = False

    End Sub
    Private Sub NavigateRecords()
        DepartmentCodeTextBox1.Text = dj.Tables("Payroll_BackEnd").Rows(inc).Item(0)
        DepartmentNameTextBox.Text = dj.Tables("Payroll_BackEnd").Rows(inc).Item(1)
    End Sub

    Private Sub PlaceButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlaceButton1.Click
        DepartmentCodeTextBox2.Text = DepartmentCodeTextBox1.Text
    End Sub
    Sub Reset()
        EmployeeCodeTextBox.Text = ""
        Employee_NameTextBox.Text = ""
        Last_NameTextBox.Text = ""
        GenderComboBox.Text = ""
        BirthDatePicker.Text = Today
        Contact_NumberTextBox.Text = ""
        AddressTextBox.Text = ""
        EmailTextBox.Text = ""
        DesignationComboBox.Text = ""
        DateEmployedPicker.Text = Today
        Basic_PayTextBox.Text = ""
        StatusComboBox.Text = ""
        PictureBox1.ImageLocation = ("C:\DefaultProfilePicture.png")
        PictureBox1.Load()
        UpdateButton1.Enabled = False
        DeleteButton1.Enabled = False
        SaveButton1.Enabled = True
        Employee_NameTextBox.Focus()
        AutoGenerate()
    End Sub
    Private Sub Add_NewButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add_NewButton1.Click
        Dim promptQuestion As DialogResult = MessageBox.Show("Are you sure you want to add a new record?", "Add New Record", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If promptQuestion = Windows.Forms.DialogResult.No Then
            Exit Sub
        End If
        Reset()
        MessageBox.Show("Successfully Cleared", "Record", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub SaveButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton1.Click
        Dim promptQuestion As DialogResult = MessageBox.Show("Are you sure you want to save this record?", "Save Record", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If promptQuestion = Windows.Forms.DialogResult.No Then

            Exit Sub
        End If
        If Len(Trim(Employee_NameTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Employee Name", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Employee_NameTextBox.Focus()
        End If
        If Len(Trim(Last_NameTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Last Name", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Last_NameTextBox.Focus()
        End If
        If Len(Trim(GenderComboBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Gender", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            GenderComboBox.Focus()
        End If
        If Len(Trim(BirthDatePicker.Value)) = 0 Then
            MessageBox.Show("Please Enter Birth Date", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            BirthDatePicker.Focus()
        End If
        If Len(Trim(Contact_NumberTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Contact Number", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Contact_NumberTextBox.Focus()
        End If
        If Len(Trim(AddressTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Address", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            AddressTextBox.Focus()
        End If
        If Len(Trim(EmailTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Email", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            EmailTextBox.Focus()
        End If
        If Len(Trim(DesignationComboBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Designation", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            DesignationComboBox.Focus()
        End If
        If Len(Trim(DateEmployedPicker.Value)) = 0 Then
            MessageBox.Show("Please Enter Date Employed", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            DateEmployedPicker.Focus()
        End If
        If Len(Trim(Basic_PayTextBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Basic Salary", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Basic_PayTextBox.Focus()
        End If
        If Len(Trim(StatusComboBox.Text)) = 0 Then
            MessageBox.Show("Please Enter Status", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            StatusComboBox.Focus()
        End If
        Try
            AutoGenerate()

            con = New OleDbConnection(dbProvider & dbSource)
            con.Open()

            Dim cb As String = "Insert INTO Staff_Details(DepartmentCode,EmployeeCode,EmployeeName,LastName,Gender,BirthDate,ContactNumber,Address,Email,Designation,DateEmployed,BasicSalary,Status,ProfilePicture) VALUES (@d1,@d2,@d3,@d4,@d5,@d6,@d7,@d8,@d9,@d10,@d11,@d12,@d13,@d14)"
            Dim MemStream As New MemoryStream
            Dim DataPic_Update As Byte()
            Me.PictureBox1.Image.Save(MemStream, Imaging.ImageFormat.Png)
            DataPic_Update = MemStream.GetBuffer()
            MemStream.Read(DataPic_Update, 0, MemStream.Length)
            cmd = New OleDbCommand(cb)
            cmd.Connection = con

            cmd.Parameters.Add(New OleDbParameter("@d1", OleDbType.VarChar, 4, "DepartmentCode"))
            cmd.Parameters.Add(New OleDbParameter("@d2", OleDbType.VarChar, 5, "EmployeeCode"))
            cmd.Parameters.Add(New OleDbParameter("@d3", OleDbType.VarChar, 20, "EmployeeName"))
            cmd.Parameters.Add(New OleDbParameter("@d4", OleDbType.VarChar, 20, "LastName"))
            cmd.Parameters.Add(New OleDbParameter("@d5", OleDbType.VarChar, 6, "Gender"))
            cmd.Parameters.Add(New OleDbParameter("@d6", OleDbType.Date, 30, "BirthDate"))
            cmd.Parameters.Add(New OleDbParameter("@d7", OleDbType.VarChar, 11, "ContactNumber"))
            cmd.Parameters.Add(New OleDbParameter("@d8", OleDbType.VarChar, 100, "Address"))
            cmd.Parameters.Add(New OleDbParameter("@d9", OleDbType.VarChar, 50, "Email"))
            cmd.Parameters.Add(New OleDbParameter("@d10", OleDbType.VarChar, 15, "Designation"))
            cmd.Parameters.Add(New OleDbParameter("@d11", OleDbType.Date, 30, "DateEmployed"))
            cmd.Parameters.Add(New OleDbParameter("@d12", OleDbType.VarChar, 10, "BasicSalary"))
            cmd.Parameters.Add(New OleDbParameter("@d13", OleDbType.VarChar, 15, "Status"))

            cmd.Parameters("@d1").Value = DepartmentCodeTextBox2.Text
            cmd.Parameters("@d2").Value = EmployeeCodeTextBox.Text
            cmd.Parameters("@d3").Value = Employee_NameTextBox.Text
            cmd.Parameters("@d4").Value = Last_NameTextBox.Text
            cmd.Parameters("@d5").Value = GenderComboBox.Text
            cmd.Parameters("@d6").Value = BirthDatePicker.Value
            cmd.Parameters("@d7").Value = Contact_NumberTextBox.Text
            cmd.Parameters("@d8").Value = AddressTextBox.Text
            cmd.Parameters("@d9").Value = EmailTextBox.Text
            cmd.Parameters("@d10").Value = DesignationComboBox.Text
            cmd.Parameters("@d11").Value = DateEmployedPicker.Value
            cmd.Parameters("@d12").Value = Basic_PayTextBox.Text
            cmd.Parameters("@d13").Value = StatusComboBox.Text

            Dim photo As OleDbParameter = New OleDbParameter("@d14", SqlDbType.Image)
            photo.Value = DataPic_Update
            cmd.Parameters.Add(photo)
            cmd.ExecuteReader()
            MessageBox.Show("Record successfully saved.")
            SaveButton1.Enabled = False
            EmployeeCodeTextBox.Focus()
            con.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Private Sub Contact_NumberTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Contact_NumberTextBox.KeyPress
        Dim phonenumber As New Regex("\d{3}-\d{7}")
        If phonenumber.IsMatch(Contact_NumberTextBox.Text) Then
            MsgBox("Valid phone number!")
        Else
            MsgBox("Not Valid phone number!")
        End If
    End Sub
    Private Sub EmailTextBox_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles EmailTextBox.Validating
        Dim rEMail As New System.Text.RegularExpressions.Regex("^[a-zA-Z][\w\.-]{2,28}[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$")
        If EmailTextBox.Text.Length > 0 Then
            If Not rEMail.IsMatch(EmailTextBox.Text) Then
                MessageBox.Show("Invalid Email Address", "Error", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                EmailTextBox.SelectAll()
                e.Cancel = True
            End If
        End If
    End Sub
    Private Sub Basic_PayTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Basic_PayTextBox.KeyPress
        Dim keyChar = e.KeyChar

        If Char.IsControl(keyChar) Then
            'Allow all control characters.
        ElseIf Char.IsDigit(keyChar) OrElse keyChar = "."c Then
            Dim text = Me.Basic_PayTextBox.Text
            Dim selectionStart = Me.Basic_PayTextBox.SelectionStart
            Dim selectionLength = Me.Basic_PayTextBox.SelectionLength

            text = text.Substring(0, selectionStart) & keyChar & text.Substring(selectionStart + selectionLength)

            If Integer.TryParse(text, New Integer) AndAlso text.Length > 16 Then
                'Reject an integer that is longer than 16 digits.
                e.Handled = True
            ElseIf Double.TryParse(text, New Double) AndAlso text.IndexOf("."c) < text.Length - 3 Then
                'Reject a real number with two many decimal places.
                e.Handled = False
            End If
        Else
            'Reject all other characters.
            e.Handled = True
        End If
    End Sub

    Private Sub Employee_NameTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Employee_NameTextBox.KeyPress
        If (Microsoft.VisualBasic.Asc(e.KeyChar) < 65) _
Or (Microsoft.VisualBasic.Asc(e.KeyChar) > 90) _
And (Microsoft.VisualBasic.Asc(e.KeyChar) < 97) _
Or (Microsoft.VisualBasic.Asc(e.KeyChar) > 122) Then
            'space accepted
            If (Microsoft.VisualBasic.Asc(e.KeyChar) <> 32) Then
                e.Handled = True
            End If
        End If
        If (Microsoft.VisualBasic.Asc(e.KeyChar) = 8) Then

            e.Handled = False
        End If
    End Sub
    Private Sub DeleteButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton1.Click
        Dim promptQuestion As DialogResult = MessageBox.Show("Are you sure you want delete this record?", "Delete Record?", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If promptQuestion = Windows.Forms.DialogResult.No Then
            Exit Sub
        End If
        Delete_Records()
        MessageBox.Show("Record successfully deleted.")
    End Sub
    Private Sub Delete_Records()

        con = New OleDbConnection(dbProvider & dbSource)

        con.Open()
        Dim ct As String = "Select EmployeeCode FROM OT_Amount WHERE EmployeeCode=@find"

        cmd = New OleDbCommand(ct)

        cmd.Connection = con
        cmd.Parameters.Add(New OleDbParameter("@find", OleDbType.VarChar, 5, "EmployeeCode"))

        cmd.Parameters("@find").Value = EmployeeCodeTextBox.Text

        rdr = cmd.ExecuteReader()

        If rdr.Read Then
            MessageBox.Show("Unable to delete..Already in use", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Reset()
            If Not rdr Is Nothing Then
                rdr.Close()
            End If
            Exit Sub
        End If

        con = New OleDbConnection(dbProvider & dbSource)

        con.Open()
        Dim ct2 As String = "Select EmployeeCode FROM Loan WHERE EmployeeCode=@find"


        cmd = New OleDbCommand(ct2)

        cmd.Connection = con
        cmd.Parameters.Add(New OleDbParameter("@find", OleDbType.VarChar, 6, "EmployeeCode"))


        cmd.Parameters("@find").Value = EmployeeCodeTextBox.Text


        rdr = cmd.ExecuteReader()

        If rdr.Read Then
            MessageBox.Show("Unable to delete..Already in use", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Reset()


            If Not rdr Is Nothing Then
                rdr.Close()
            End If
            Exit Sub
        End If

        con = New OleDbConnection(dbProvider & dbSource)

        con.Open()
        Dim ct1 As String = "Select EmployeeCode FROM Payroll_Calculator WHERE EmployeeCode=@find"


        cmd = New OleDbCommand(ct1)

        cmd.Connection = con
        cmd.Parameters.Add(New OleDbParameter("@find", OleDbType.VarChar, 6, "EmployeeCode"))


        cmd.Parameters("@find").Value = EmployeeCodeTextBox.Text


        rdr = cmd.ExecuteReader()

        If rdr.Read Then
            MessageBox.Show("Unable to delete..Already in use", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Reset()



            If Not rdr Is Nothing Then
                rdr.Close()
            End If
            Exit Sub
        End If

        Dim RowsAffected As Integer = 0

        con = New OleDbConnection(dbProvider & dbSource)

        con.Open()


        Dim cq As String = "Delete from Staff_Details where EmployeeCode=@DELETE1;"


        cmd = New OleDbCommand(cq)

        cmd.Connection = con

        cmd.Parameters.Add(New OleDbParameter("@DELETE1", OleDbType.VarChar, 6, "EmployeeCode"))


        cmd.Parameters("@DELETE1").Value = Trim(EmployeeCodeTextBox.Text)
        RowsAffected = cmd.ExecuteNonQuery()
        If RowsAffected > 0 Then

            MessageBox.Show("Successfully Deleted", "Record", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Reset()
            Employee_NameTextBox.Focus()
            UpdateButton1.Enabled = False
            DeleteButton1.Enabled = False
        Else
            MessageBox.Show("No Record Found", "Sorry", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Reset()
            If con.State = ConnectionState.Open Then

                con.Close()
            End If

            con.Close()
        End If

    End Sub

    Private Sub ButtonSpecAny1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSpecAny1.Click
        GenderComboBox.Text = ""
    End Sub

    Private Sub ButtonSpecAny3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSpecAny3.Click
        DesignationComboBox.Text = ""
    End Sub

    Private Sub ButtonSpecAny2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSpecAny2.Click
        StatusComboBox.Text = ""
    End Sub

    Private Sub ExitButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton1.Click
        If MsgBox("Are You Sure You Want To Quit The Program?", vbYesNo, Title:="Close Confirmation") = vbYes Then
            Me.Close()
        End If
    End Sub

    Private Sub UpdateButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateButton1.Click
        If Len(Trim(EmployeeCodeTextBox.Text)) = 0 Then
            MessageBox.Show("Please Select Employee Code", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            EmployeeCodeTextBox.Focus()
            Exit Sub
        End If
        con = New OleDbConnection(dbProvider & dbSource)
        con.Open()

        Dim cb As String = "Update Staff_Details set EmployeeName='" & Employee_NameTextBox.Text & "',LastName='" & Last_NameTextBox.Text & "',Gender='" & GenderComboBox.Text & "',BirthDate='" & BirthDatePicker.Value & "',ContactNumber='" & Contact_NumberTextBox.Text & "',Address='" & AddressTextBox.Text & "',Email='" & EmailTextBox.Text & "',Designation='" & DesignationComboBox.Text & "',DateEmployed='" & DateEmployedPicker.Value & "',BasicSalary='" & Basic_PayTextBox.Text & "',Status='" & StatusComboBox.Text & "',ProfilePicture='" & PictureBox1.ImageLocation & "',WHERE EmployeeCode='" & EmployeeCodeTextBox.Text & "' DepartmentCode='" & DepartmentCodeTextBox2.Text & "'"

        cmd = New OleDbCommand(cb)

        cmd.Connection = con

        If MessageBox.Show("Are you sure want to update the record?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then

            cmd.ExecuteReader()
            MessageBox.Show("Successfully Updated", "Staff Details", MessageBoxButtons.OK, MessageBoxIcon.Information)

            Employee_NameTextBox.Focus()
            UpdateButton1.Enabled = False

        End If
        If con.State = ConnectionState.Open Then
            con.Close()
        End If

        con.Close()
    End Sub
    'Browse
    Private Sub BrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BrowseButton.Click
        With OpenFileDialog1
            .InitialDirectory = "C:\Users\user\Documents\Visual Studio 2010\Projects\FINALE\Bakery Payroll System - Nayomi's\Profile_Pictures"
            .Filter = "Bitmaps (*.bmp)|*.bmp|GIFs (*.gif)|*.gif|JPEGs (*.jpg)|*.jpg|PNGs (*.png)|*.png|All Image File (*.jpg,*.bmp,*.gif,*.png)|*.jpg;*.bmp;*.gif;*.png"
            .FilterIndex = 2
        End With

        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            With PictureBox1
                .Image = Image.FromFile(Me.OpenFileDialog1.FileName)
                .SizeMode = PictureBoxSizeMode.AutoSize
            End With

        End If
    End Sub

    Private Sub NextRecordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextRecordButton.Click
        If inc <> MaxRows - 1 Then

            inc = inc + 1

            NavigateRecords()

        Else

            MsgBox("No More Rows")

        End If
    End Sub

    Private Sub PreviousRecordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PreviousRecordButton.Click
        If inc > 0 Then

            inc = inc - 1

            NavigateRecords()

        ElseIf inc = -1 Then

            MsgBox("No Records Yet")

        ElseIf inc = 0 Then

            MsgBox("First Record")

        End If
    End Sub

    Private Sub FirstRecordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirstRecordButton.Click
        If inc <> 0 Then
            MsgBox("This is the First Record")
            inc = 0

            NavigateRecords()

        End If
    End Sub

    Private Sub LastRecordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LastRecordButton.Click
        If inc <> MaxRows - 1 Then
            MsgBox("This is the Last Record")
            inc = MaxRows - 1

            NavigateRecords()

        End If
    End Sub

    Private Sub BindingNavigator2_RefreshItems(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BindingNavigator2.RefreshItems
        Me.Validate()
        Me.Staff_DetailsBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.Payroll_BackEndDataSet)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        DateLabel.Text = Today
        TimeLabel.Text = TimeOfDay
    End Sub
End Class

