﻿Public Class XtraMain_Menu

    Private Sub XtraMain_Menu_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ComputerNameLabel.Text = System.Environment.MachineName
        OperatingSystemLabel.Text = My.Computer.Info.OSFullName
        PlatformLabel.Text = My.Computer.Info.OSPlatform
        PhysicalMemeoryLabel.Text = My.Computer.Info.TotalPhysicalMemory
        VirtualMemoryLabel.Text = My.Computer.Info.TotalVirtualMemory
    End Sub

    Private Sub EmployeeDetailsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EmployeeDetailsButton.Click
        Me.Hide()
        Employee_Info.Show()
    End Sub


    Private Sub StaffEditorButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StaffEditorButton.Click
        Me.Hide()
        Staff_Editor.Show()
    End Sub

    Private Sub CalcPayrollButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcPayrollButton.Click
        Me.Hide()
        Payroll_Calculator.Show()
    End Sub

    Private Sub ChangePasswordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangePasswordButton.Click
        Me.Hide()
        frm_BG2.Show()
        frm_Change_Password.ShowDialog()
    End Sub
    Private Sub LogOutButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LogOutButton.Click
        If MsgBox("Are You Sure You Want To Log off?", vbYesNo, Title:="Log off Confirmation") = vbYes Then
            MsgBox("User Successfully Logged Off")
            Me.Hide()
            AxWindowsMediaPlayer2.URL = "C:\bye.mp3"
            MsgBox("The Program Will Now Exit!")
            Login_Form.Show()
            Login_Form.cmbUser_Type.Text = ""
            Login_Form.txtUsername.Clear()
            Login_Form.txtPassword.Clear()
            Login_Form.cmbUser_Type.Focus()
        End If
    End Sub
    Private Sub SearchButton_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchButton.Click
        Search.Show()
        Me.Hide()
    End Sub

    Private Sub MonthlyRptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MonthlyRptButton.Click
        Report_Monthly.Show()
        Me.Hide()
    End Sub

    Private Sub YearlyRptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles YearlyRptButton.Click
        Report_Yearly.Show()
        Me.Hide()
    End Sub

    Private Sub EmployeeCodeRptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EmployeeCodeRptButton.Click
        Report_Employee.Show()
        Me.Hide()
    End Sub

    Private Sub DepartmentRptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DepartmentRptButton.Click
        Report_Department.Show()
        Me.Hide()
    End Sub

    Private Sub CalcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcButton.Click
        System.Diagnostics.Process.Start("Calc.exe")
    End Sub

    Private Sub NotepadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NotepadButton.Click
        System.Diagnostics.Process.Start("Notepad.exe")
    End Sub

    Private Sub WordpadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WordpadButton.Click
        System.Diagnostics.Process.Start("Wordpad.exe")
    End Sub

    Private Sub MsWordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MsWordButton.Click
        System.Diagnostics.Process.Start("WinWord.exe")
    End Sub

    Private Sub MsAccessButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MsAccessButton.Click
        System.Diagnostics.Process.Start("Msaccess.exe")
    End Sub

    Private Sub MsExcelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MsExcelButton.Click
        System.Diagnostics.Process.Start("Excel.exe")
    End Sub

    Private Sub WebBrowserButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WebBrowserButton.Click
        System.Diagnostics.Process.Start("Firefox.exe")
    End Sub
    Private Sub TaskmgrButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TaskmgrButton.Click
        System.Diagnostics.Process.Start("Taskmgr.exe")
    End Sub

    Private Sub Date_TimeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Date_TimeButton.Click
        System.Diagnostics.Process.Start("Timedate.cpl")
    End Sub

    Private Sub SysinfoButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SysinfoButton.Click
        frm_System_Info.Show()
        frm_BG3.Show()
        Me.Hide()
    End Sub
    Private Sub AboutButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutButton.Click
        frm_About.Show()
    End Sub

    Private Sub Backup_RestoreButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Backup_RestoreButton.Click
        frmBackup_Restore.Show()
        frm_BG4.Show()
        Me.Hide()
    End Sub
End Class