﻿Imports System.IO

Public Class frmBackup_Restore

    Private Sub Backup_Restore_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim r As Rectangle = Me.Bounds
        Me.Owner = frm_BG4
    End Sub

    Private Sub Backup_Restore_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        Dim r As Rectangle = Me.Bounds
        r.Inflate(35, 35)
        frm_BG4.Bounds = r
    End Sub

    Private Sub HomeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeButton.Click
        XtraMain_Menu.Show()
        frm_BG4.Hide()
        Me.Hide()
    End Sub

    Private Sub BackButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BackButton.Click
        XtraMain_Menu.Show()
        frm_BG4.Hide()
        Me.Hide()
    End Sub

    Private Sub BackupButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BackupButton.Click
        Try

            Dim s As StreamWriter

            Dim portfolioPath As String = My.Application.Info.DirectoryPath

            If Not Directory.Exists("C:\Backup") Then

                Directory.CreateDirectory("C:\Backup")

                File.Create("C:\ Backup\Payroll_BackEnd.accdb").Close()

                File.Create("C: \Backup\Backup log.TXT").Close()

                s = New StreamWriter("C:\Backup\Backup log.TXT", True)

                s.WriteLine("This backup was initially taken on - " & Date.Now)

                s.Flush()

                s.Close()

                FileCopy(portfolioPath & "\Payroll_BackEnd.accdb", "C:\Backup\Payroll_BackEnd.accdb")

                s = New StreamWriter("C:\Backup\Backup log.TXT", True)

                MsgBox("New directory and backup file created")

            Else

                FileCopy(portfolioPath & "\Payroll_BackEnd.accdb", "C:\Backup\Payroll_BackEnd.accdb")

                s = New StreamWriter("C:\Backup\Backup log.TXT", True)

                s.WriteLine("This backup was latest updated on - " & Date.Now)

                s.Flush()

                s.Close()

                MsgBox("Back up completed successfully")

            End If

        Catch ex As Exception

            Dim MessageString As String = "Report this error to the system administrator: " & ControlChars.NewLine & ex.Message

            Dim TitleString As String = "Payroll Details Data Load Failed"

            MessageBox.Show(MessageString, TitleString, MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try
    End Sub

    Private Sub RestoreButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RestoreButton.Click
        Try

            Dim portfolioPath As String = My.Application.Info.DirectoryPath

            If MessageBox.Show("Restoring the database will erase any changes you have made since you last backup. Are you sure you want to do this?", "Confirm Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.OK Then

                FileCopy("C:\Backup\Payroll_BackEnd.accdb", portfolioPath & "\Payroll_BackEnd.accdb")

            End If

            MsgBox("Database Restoration Successful")

        Catch ex As Exception

            Dim MessageString As String = "Report this error to the system administrator: " & ControlChars.NewLine & ex.Message

            Dim TitleString As String = "Payroll Details Data Load Failed"

            MessageBox.Show(MessageString, TitleString, MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

    End Sub
End Class
