﻿Imports CompletIT.Windows.Forms.Export.Pdf
Imports CompletIT.Windows.Forms.Export
Imports CompletIT.Windows.Forms.Export.Excel
Imports CompletIT.Windows.Forms.Printing
Imports CompletIT.Windows.Forms.Export.Html
Public Class Report_Monthly

    Private Sub Report_Monthly_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'Payroll_BackEndDataSet1.Payroll_Calculator' table. You can move, or remove it, as needed.
        Me.Payroll_CalculatorTableAdapter.Fill(Me.Payroll_BackEndDataSet1.Payroll_Calculator)
        Payroll_CalculatorDataGridView.ForeColor = Color.Black
    End Sub
    Private Sub Pay_CalculatorBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.Validate()
        Me.Payroll_CalculatorBindingSource.EndEdit()
        Me.TableAdapterManager1.UpdateAll(Me.Payroll_BackEndDataSet1)
    End Sub
    Private Sub TextBox1_KeyUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.KeyUp
        Payroll_CalculatorBindingSource.Filter = String.Format("[MonthName] like '{0}%'", Me.TextBox1.Text)
    End Sub

    Private Sub TextBox2_KeyUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.KeyUp
        Payroll_CalculatorBindingSource.Filter = String.Format("[MonthNumber] like '{0}%'", Me.TextBox2.Text)
    End Sub

    Private Sub Print_PreviewButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Print_PreviewButton.Click
        'Note! There is overload of the PrintPreview 
        'method which accepts print settings (DGVEPrintSettings); 
        DGVEPrintManager.PrintPreview(Payroll_CalculatorDataGridView)
    End Sub

    Private Sub Print_ReportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Print_ReportButton.Click
        DGVEPrintManager.Print(Payroll_CalculatorDataGridView, cbpd.Checked)        'Note! There is overload of the Print
        'method which accepts print settings (DGVEPrintSettings)
    End Sub
    Private Sub exporter_ExportFailed(ByVal sender As Object, ByVal e As CompletIT.Windows.Forms.Export.ExportFailedEventArgs)
        'Show message box with the occured exception 
        MessageBox.Show(e.Exception.Message)
    End Sub
    Private Sub XportPDFButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XportPDFButton.Click
        'You can export any DataGridView control, no matter managed or not by the extension
        Dim pdfExporter As DGVEPdfExporter = New DGVEPdfExporter()
        Dim dialog As DGVEBaseExportSettingsEditorForm = DGVEExportSettingsEditorFormBuilder.CreateWrappingForm(pdfExporter)
        dialog.Settings = New DGVEPdfExportSettings()
        If (DialogResult.OK <> dialog.ShowDialog()) Then
            Return
        End If

        AddHandler pdfExporter.ExportFailed, AddressOf exporter_ExportFailed
        pdfExporter.Export(Payroll_CalculatorDataGridView, dialog.Settings)
    End Sub

    Private Sub XportExcelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XportExcelButton.Click
        'These lines of code export the data grid to excel
        Dim editor As DGVEExcelExportSettingsEditor = New DGVEExcelExportSettingsEditor()
        Dim settings As DGVEExcelExportSettings = New DGVEExcelExportSettings()
        'Set values to any of the other properties of the settings object...
        Dim dialog As DGVEBaseExportSettingsEditorForm = DGVEExportSettingsEditorFormBuilder.CreateWrappingForm(editor)
        dialog.Settings = settings
        If (DialogResult.OK <> dialog.ShowDialog()) Then
            Return
        End If
        Dim exporter As DGVEExcelExporter = New DGVEExcelExporter()
        AddHandler exporter.ExportFailed, AddressOf exporter_ExportFailed
        exporter.Export(Payroll_CalculatorDataGridView, settings)
    End Sub

    Private Sub XportHTMLButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XportHTMLButton.Click
        'These lines of code export the data grid to HTML
        Dim htmlExporter As DGVEHtmlExporter = New DGVEHtmlExporter()
        Dim dialog As DGVEBaseExportSettingsEditorForm = DGVEExportSettingsEditorFormBuilder.CreateWrappingForm(htmlExporter)
        'Pass the default settings from the exporter to the editor control
        dialog.Settings = htmlExporter.DefaultSettings
        If (DialogResult.OK <> dialog.ShowDialog()) Then
            Return
        End If
        AddHandler htmlExporter.ExportFailed, AddressOf exporter_ExportFailed
        htmlExporter.Export(Payroll_CalculatorDataGridView, dialog.Settings)
    End Sub

    Private Sub BackButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BackButton.Click
        Me.Hide()
        XtraMain_Menu.Show()
    End Sub

    Private Sub HomeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeButton.Click
        Me.Hide()
        XtraMain_Menu.Show()
    End Sub

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        If MsgBox("Are You Sure You Want To Quit The Program?", vbYesNo, Title:="Close Confirmation") = vbYes Then
            Me.Close()
        End If
    End Sub
End Class